; Projekt 2: Bc svtlo
     LIST		p=16F88				; nastaven typu procesoru
     #INCLUDE	<P16F88.INC>		; definice promnnch pro tento procesor

;------------------------------------------------------------------------------
; NASTAVEN KONFIGURANHO SLOVA
;------------------------------------------------------------------------------

	__CONFIG	_CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _INTRC_IO
	__CONFIG	_CONFIG2, _IESO_OFF & _FCMEN_OFF

;------------------------------------------------------------------------------
; DEFINICE PROMNNCH
;------------------------------------------------------------------------------
d1		EQU		0x7F

;------------------------------------------------------------------------------
; RESET VEKTOR
;------------------------------------------------------------------------------

RESET	ORG		0x0000		; zatek programu na adrese 0000h

; Inicializace port
		BANKSEL PORTA		; vbr banky, ve kter se nachz registr PORTA
		CLRF    PORTA		; inicializace PORTA
		CLRF    PORTB		; inicializace PORTB

		BANKSEL	ANSEL		; vbr banky, ve kter se nachz registr ANSEL
		CLRF	ANSEL		; piny AN<6:0> jako digitln I/O

		CLRF	TRISA		; Piny RA<7:0> jako vstupy
		CLRF	TRISB		; Piny RB<7:0> jako vstupy

; Inicializace promnnch
		BANKSEL	PORTB		; vbr banky 0
		BCF		STATUS, C	; vynulovn bitu Carry
		BSF		PORTB, 0	; RB0 = 1

; Vlastn program
ROT_LEFT
		RLF		PORTB, f	; rotace registru PORTB vlevo
		CALL	DELAY		; voln ekac smyky
		BTFSS	PORTB, 7	; test bitu RB7 registru PORTB
		GOTO	ROT_LEFT	; je-li RB7=0, skok na ROT_LEFT
							; je-li RB7=1, pedchoz instrukce se pesko
ROT_RIGHT
		RRF		PORTB, f	; rotace registru PORTB vpravo
		CALL	DELAY		; voln ekac smyky
		BTFSS	PORTB, 0	; test bitu RB0 registru PORTB
		GOTO	ROT_RIGHT	; je-li RB0=0, skok na ROT_RIGHT
		GOTO	ROT_LEFT	; je-li RB0=1, pedchoz instrukce se pesko
							; a provede se skok na ROT_LEFT

; Podprogram DELAY s ekac smykou
DELAY
		DECFSZ	d1, f		; d1 = d1 - 1
		GOTO	DELAY		; je-li d1 > 0, provede se skok na DELAY
		RETURN				; je-li d1 = 0, provede se nvrat z podprogramu


		END