	title "Pklady demonstrujc pouit instrukc pro stn a odtn"

; Seril "Mikrokontrolry PIC", dl 24
; PE 12/2009
;
; Vt pringl
; 
	LIST		p=16F88
	#INCLUDE	<P16F88.INC>

; === DEFINICE PROMNNCH ===
	CBLOCK 0x20
		m
		n
	ENDC

; === RESET VEKTOR ===
reset:	ORG		0x0000

; Inicializace promnnch

	MOVLW	0x33	; 33h -> W
	MOVWF	m		; W -> m, m = 00110011b

	MOVLW	0xA6	; inicializace W
					; W = A6h = 10100110b
; Program
; stn
	ADDWF	m, W	; m + W, 33h + A6 = D9h
					; vsledek -> W = D9h = 11011001b
					; Z = 0, C = 0, DC = 0, m beze zmny

	ADDWF	m, W	; m + W, 33h + D9h = 10Ch
					; vsledek -> W = 0Ch = 00001100b
					; Z = 0, C = 1, DC = 0, m beze zmny

	ADDLW	0x06	; 06h + W, 06h + 0Ch = 12h
					; vsledek -> W = 12h = 00010010b
					; Z = 0, C = 0, DC = 1

	ADDLW	0x0E	; (0Eh = 00001110b)
					; 0Eh + W, 0Eh + 12h = 20h
					; vsledek -> W = 20h = 00100000b
					; Z = 0, C = 0, DC = 1

	ADDLW	0xE0	; (E0h = 11100000b)
					; E0h + W, E0h + 20h = 100h
					; vsledek -> W = 00h
					; Z = 1, C = 1, DC = 0

; odtn
	ADDLW	-0xE0	; (-E0h = 20h)
					; 20h + W, 20h + 00h = 20h
					; vsledek -> W = 20h = 00100000b
					; Z = 0, C = 0, DC = 0

	MOVWF	n		; W -> n, n = 20h
	MOVLW	0x0E	; 0Eh -> W, W = 0Eh = 00001110b

	SUBWF	n, f	; n - W, 20h - 0Eh = 12h
					; vsledek -> n = 12h = 00010010b
					; Z = 0, C = 1, DC = 0
	
	MOVF	m, W	; m -> W, W = 33h = 00110011b
	SUBWF	n, f	; n - W, 12h - 33h = DFh
					; vsledek -> n = DFh = 11011111b
					; Z = 0, C = 0, DC = 0

	SUBWF	n, W	; n - W, DFh - 33h = ACh
					; vsledek -> W = ACh = 10101100b
					; Z = 0, C = 1, DC = 1

	ADDLW	-0x06	; (-06h = FAh)
					; FAh + W, FAh + ACh = A6h
					; vsledek -> W = A6h = 10100110b
					; Z = 0, C = 1, DC = 1

loop:
	GOTO	loop

	END
	
