	title "Prce s modulem asovae Timer0"

; Seril "Mikrokontrolry PIC", dl 41
; PE-AR 05/2011
;
; Vt pringl
;
; Popis: Blikajc LED, jej perioda je zena asovaem Timer0 (bez pouit peruen)

     LIST		p=16F88				; nastaven typu procesoru
     #INCLUDE	<P16F88.INC>		; definice promnnch pro tento procesor

; === NASTAVEN KONFIGURANHO SLOVA ===
	__CONFIG	_CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _INTRC_IO
	__CONFIG	_CONFIG2, _IESO_OFF & _FCMEN_OFF

; === VEKTOR RESETU ===
RESET	ORG		0x0000		; zatek programu na adrese 0000h

; Inicializace port
	BCF		STATUS, RP0		; vbr banky 0
	CLRF	PORTA			; inicializace PORTA
	CLRF	PORTB			; inicializace PORTB

	BSF		STATUS, RP0		; vbr banky 1
	CLRF	ANSEL			; piny AN<6:0> jako digitln I/O
	CLRF	TRISA			; Piny RA<7:0> jako vstupy
	CLRF	TRISB			; Piny RB<7:0> jako vstupy

; Inicializace asovae Timer0
	MOVLW	b'11010100'
	MOVWF	OPTION_REG		; Zdroj signlu pro asova TMR0: intern instrukn cyklus, 
							; dlika piazena TMR0, dl. pomr: 1:32
	BCF		STATUS, RP0		; vbr banky 0

; Hlavn smyka programu
MAIN
	; zde me bt dal kd
	BTFSS	INTCON, TMR0IF	; dolo k peteen tae TMR0?
	GOTO	MAIN			;  - ne: skok na MAIN
	BCF		INTCON, TMR0IF	;  - ano: vynuluj pznakov bit
	MOVLW	b'00000001'
	XORWF	PORTB,f			; zm rove na RB0
	GOTO	MAIN	

	END