; Projekt: Blikajc LED

	LIST	p=16F88		; nastaven typu procesoru
	#INCLUDE	<P16F88.INC>	; definice promnnch pro tento procesor

;------------------------------------------------------------------------------
; NASTAVEN KONFIGURANHO SLOVA
; (direktiva __CONFIG mus bt na jednom dku)
;------------------------------------------------------------------------------

	__CONFIG	_CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _INTRC_IO
	__CONFIG	_CONFIG2, _IESO_OFF & _FCMEN_OFF

;------------------------------------------------------------------------------
; DEFINICE PROMNNCH
;------------------------------------------------------------------------------

d1	EQU	0x7F
RB4	EQU	0x04

;------------------------------------------------------------------------------
; VLASTN PROGRAM
;------------------------------------------------------------------------------

RESET	ORG	0x0000		; zatek programu na adrese 0000h

; Inicializace port
	BANKSEL	PORTA		; vbr banky, ve kter se nachz registr PORTA
	CLRF	PORTA		; vynulovn PORTA
	CLRF	PORTB		; vynulovn PORTB

	BANKSEL	ANSEL		; vbr banky, ve kter se nachz registr ANSEL
	CLRF	ANSEL		; piny AN<6:0> jako digitln I/O

	CLRF	TRISA		; piny RA<7:0> jako vstupy
	CLRF	TRISB		; piny RB<7:0> jako vstupy

; Ovldn LED
	BANKSEL	PORTB		; vbr banky 0
LOOP
	CALL	DELAY		; voln podprogramu DELAY (ekac smyka)
	BSF	PORTB, RB4	; RB4 = H
	CALL	DELAY		; voln podprogramu DELAY (ekac smyka)
	BCF	PORTB, RB4	; RB4 = L
	GOTO	LOOP		; skok na LOOP

; Podprogram DELAY s ekac smykou
DELAY					
	MOVLW	.255		; pesu konstantu 255 do pracovnho registru W
	MOVWF	d1		; pesu obsah registru W do promnn d1
DELAY_0
	DECFSZ	d1, f		; odeti jedniku od hodnoty registru d1
	GOTO	DELAY_0		; je-li d1 > 0, provede se skok na DELAY_0
	RETURN			; je-li d1 = 0, provede se nvrat z podprogramu

	END
