; Projekt: Blikajc LED
     LIST		p=16F88				; nastaven typu procesoru
     #INCLUDE	<P16F88.INC>		; definice promnnch pro tento procesor

;------------------------------------------------------------------------------
; NASTAVEN KONFIGURANHO SLOVA
;------------------------------------------------------------------------------

	__CONFIG	_CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _INTRC_IO
	__CONFIG	_CONFIG2, _IESO_OFF & _FCMEN_OFF

;------------------------------------------------------------------------------
; DEFINICE PROMNNCH
;------------------------------------------------------------------------------

d1		EQU		0x7F
RB4		EQU		0x04

;------------------------------------------------------------------------------
; RESET VEKTOR
;------------------------------------------------------------------------------

RESET	ORG		0x0000            ; zatek programu na adrese 0000h

; Inicializace internho osciltoru
		BANKSEL	OSCCON
		BSF		OSCCON, 4	; kmitoet 125kHz

; Inicializace port
		BANKSEL PORTA		; vbr banky, ve kter se nachz registr PORTA
		CLRF    PORTA		; inicializace PORTA
		CLRF    PORTB		; inicializace PORTB

		BANKSEL	ANSEL		; vbr banky, ve kter se nachz registr ANSEL
		CLRF	ANSEL		; piny AN<6:0> jako digitln I/O

		CLRF	TRISA		; Piny RA<7:0> jako vstupy
		CLRF	TRISB		; Piny RB<7:0> jako vstupy

; Vlastn program
		BANKSEL	PORTB		; vbr banky 0
LOOP
		call	Delay		; voln podprogramu Delay (ekac smyka)
		bsf		PORTB, RB4	; RB4 = H
		call	Delay		; voln podprogramu Delay (ekac smyka)
		bcf		PORTB, RB4	; RB4 = L
		goto	LOOP		; skok na LOOP

; Podprogram Delay s ekac smykou
Delay					
		movlw	.255		; pesu konstantu 255 do pracovnho registru W
		movwf	d1			; pesu obsah registru W do promnn d1
Delay_0
		decfsz	d1, f		; odeti jedniku od hodnoty registru d1
		goto	Delay_0		; je-li d1 > 0, provede se skok na Delay_0
		return				; je-li d1 = 0, provede se nvrat z podprogramu



		END
