; Projekt: Blikajc LED
     LIST		p=16F88				; nastaven typu procesoru
     #INCLUDE	<P16F88.INC>		; definice promnnch pro tento procesor

;------------------------------------------------------------------------------
; NASTAVEN KONFIGURANHO SLOVA
;------------------------------------------------------------------------------

	__CONFIG	_CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _INTRC_IO
	__CONFIG	_CONFIG2, _IESO_OFF & _FCMEN_OFF

;------------------------------------------------------------------------------
; DEFINICE PROMNNCH
;------------------------------------------------------------------------------

d1		EQU		0x7F
d2		EQU		0x7E
RB4		EQU		0x04

;------------------------------------------------------------------------------
; RESET VEKTOR
;------------------------------------------------------------------------------

RESET	ORG		0x0000		; zatek programu na adrese 0000h

; Inicializace internho osciltoru
		BANKSEL	OSCCON
		BSF		OSCCON, 4	; kmitoet 125kHz

; Inicializace port
		BANKSEL PORTA		; vbr banky, ve kter se nachz registr PORTA
		CLRF    PORTA		; inicializace PORTA
		CLRF    PORTB		; inicializace PORTB

		BANKSEL	ANSEL		; vbr banky, ve kter se nachz registr ANSEL
		CLRF	ANSEL		; piny AN<6:0> jako digitln I/O

		CLRF	TRISA		; Piny RA<7:0> jako vstupy
		CLRF	TRISB		; Piny RB<7:0> jako vstupy

; Vlastn program
		BANKSEL	PORTB		; vbr banky 0
LOOP
		CALL	DELAY		; voln podprogramu DELAY (ekac smyka)
		BSF		PORTB, RB4	; RB4 = H
		CALL	DELAY		; voln podprogramu DELAY (ekac smyka)
		BCF		PORTB, RB4	; RB4 = L
		GOTO	LOOP		; skok na LOOP

; Podprogram DELAY s ekac smykou
DELAY
		DECFSZ	d1, f		; odeti jedniku od hodnoty registru d1
		GOTO	DELAY		; je-li d1 > 0, provede se skok na DELAY
		DECFSZ	d2, f		; je-li d1 = 0, odete se jednika od d2
		GOTO	DELAY		; je-li d2 > 0, provede se skok na DELAY
		RETURN				; je-li d2 = 0, provede se nvrat z podprogramu



		END
