	title "Pklady demonstrujc pouit instrukc provdjcch logick operace AND, OR, XOR a NOT"

; Seril "Mikrokontrolry PIC", dl 24
; PE 12/2009
;
; Vt pringl
; 
	LIST		p=16F88
	#INCLUDE	<P16F88.INC>

; === DEFINICE PROMNNCH ===
	CBLOCK 0x20
		m
		n
	ENDC

; === RESET VEKTOR ===
reset:	ORG		0x0000

; Inicializace promnnch

	MOVLW	0x33	; 33h -> W
	MOVWF	m		; W -> m, m = 00110011b
	MOVLW	0xA6	; A6h -> W
	MOVWF	n		; W -> n, n = 10100110b

	MOVLW	0xC0	; inicializace W,
					; W = C0h = 11000000b
; Program
	ANDWF	m, W	; m AND W, 33h AND C0 = 00h
					; vsledek -> W = 00h
					; Z = 1, m beze zmny

	IORWF	0x21, W	; n OR W, A6h OR 00h = A6h
					; vsledek -> W = A6h = 10100110b
					; Z = 0, n beze zmny
	
	IORLW	0x21	; (21h = 00100001b)
					; 21h OR W, 21h OR A6h = A7h
					; vsledek -> W = A7h = 10100111b
					; Z = 0

	COMF	n, f	; /n, /n = 59h
					; vsledek -> n = 59h = 01011001b
					; Z = 0, W beze zmny
	
	XORWF	m, f	; m XOR W, 33h XOR A7h = 94h
					; vsledek -> m = 94h = 10010100b
					; Z = 0, W beze zmny

	XORWF	m, W	; m XOR W, 94h XOR A7h = 33h
					; vsledek -> W = 33h = 00110011b
					; Z = 0, m beze zmny

	XORWF	m, f	; m XOR W, 94h XOR 33h = A7h
					; vsledek -> m = A7h = 10100111b
					; Z = 0, W beze zmny
loop:
	GOTO	loop

	END
	



