; Seril "Mikrokontrolry PIC", dl 25
; PE 1/2010
;
; Vt pringl
; 
	LIST		p=16F88
	#INCLUDE	<P16F88.INC>

; === DEFINICE PROMNNCH ===
	CBLOCK 0x20
		m
		n
	ENDC

; === RESET VEKTOR ===
reset:	ORG		0x0000

; Inicializace promnnch
; instrukce decf, incf, btfsc, btfss, (decfsz, incfsz), bsf, bcf, clrf, clrw, clrwdt,
; movlw, movf, mowf, swapf

	MOVLW	0x03	; 03h -> W
	MOVWF	m		; W -> m, m = 00000011b
	MOVLW	0xA6	; A6h -> W
	MOVWF	n		; W -> n, n = 10100110b

; Hlavn program

loop1:
	INCF	m, f	; m = m + 1
	BTFSS	m, 3	; nsledujc instukce se pesko,
					; je-li bit3 = 1, v tomto ppad
					; jakmile m = 00001000b = 08h
	GOTO	loop1	; skok se tedy provede celkem 4krt

loop2:
	DECF	m, f	; m = m - 1
	BTFSC	m, 2	; nsledujc instukce se pesko,
					; je-li bit2 = 0, v tomto ppad
					; jakmile m = 00000011b = 03h
	GOTO	loop2	; skok se tedy provede opt 4krt

loop3:
	DECFSZ	m, f	; m = m - 1, nsledujc instrukce se
					; pesko, je-li po dekrementaci m = 0
	GOTO	loop3	; skok se tedy provede celkem 2krt

	; n -> m	
	MOVF	n, W	; n -> W
	MOVWF	m		; W -> m, m = n = A6h

	BSF		m, 3	; m<3> = 1, m = 10101110b = AEh
	
	BCF		n, 5	; n<5> = 0, n = 10000110b = 86h

	SWAPF	n, f	; n = 68h;

loop_end:
	GOTO	loop_end

	END
	



