	title "Read-Modify-Write test 1"

; Seril "Mikrokontrolry PIC", dl 28
; PE 04/2010
;
; Vt pringl
;

     LIST		p=16F88				; nastaven typu procesoru
     #INCLUDE	<P16F88.INC>		; definice promnnch pro tento procesor

;------------------------------------------------------------------------------
; NASTAVEN KONFIGURANHO SLOVA
;------------------------------------------------------------------------------

	__CONFIG	_CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _INTRC_IO
	__CONFIG	_CONFIG2, _IESO_OFF & _FCMEN_OFF

;------------------------------------------------------------------------------
; DEFINICE PROMNNCH
;------------------------------------------------------------------------------

d1		EQU		0x7F

;------------------------------------------------------------------------------
; VLASTN PROGRAM
;------------------------------------------------------------------------------

RESET	ORG		0x0000	; processor reset vector

	
	CLRF	PORTB		; RB<7:0> = L
	
	BSF		STATUS, RP0	; banka 1
	CLRF	ANSEL		; piny AN<6:0> jako digitln I/O
	CLRF	TRISB		; vechny piny portu B jako vstupy

LOOP	
	BSF		STATUS, RP0	; banka 1
	BSF		TRISB, 0	; RB0 jako vstup

	BCF		STATUS, RP0	; banka 0
	BSF		PORTB, 7	; RB7 = H

	BSF		STATUS, RP0	; banka 1
	BCF		TRISB, 0	; RB0 jako vstup

	CALL	DELAY
	GOTO	LOOP

DELAY
	DECFSZ	d1, f
	GOTO	DELAY
	RETURN

	END