	title "Odstrann zkmit tlatka n-nsobnm kontinulnm tenm"

; Seril "Mikrokontrolry PIC", dl 33
; PE 09/2010
;
; Vt pringl
;

     LIST		p=16F88				; nastaven typu procesoru
     #INCLUDE	<P16F88.INC>		; definice promnnch pro tento procesor

; === NASTAVEN KONFIGURANHO SLOVA ===

	__CONFIG	_CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _INTRC_IO
	__CONFIG	_CONFIG2, _IESO_OFF & _FCMEN_OFF

; === DEFINICE PROMNNCH ===
	CBLOCK	0x20
		count			; aktuln poet ten vstupu
		count1			; 
	ENDC

; === KONSTATNTY ===
DEF_COUNT	EQU	0xFF	; vchoz poet ten vstupu pro count
DEF_COUNT1	EQU	0x20	; vchoz poet ten vstupu pro count1

; === PROGRAM ===
RESET	ORG		0x0000		; zatek programu na adrese 0000h

; Inicializace port
		BCF		STATUS, RP0	; vbr banky 0
		CLRF	PORTA		; inicializace PORTA
		MOVLW	0x01
		MOVWF	PORTB		; inicializace PORTB

		BSF		STATUS, RP0	; vbr banky 1
		CLRF	ANSEL		; piny AN<6:0> jako digitln I/O
		MOVLW	0x01
		MOVWF	TRISA		; Piny RA<7:1> jako vstupy, RA0 jako vstup
		CLRF	TRISB		; Piny RB<7:0> jako vstupy

; Inicializace internho osciltoru
		MOVLW	b'01110000'
		MOVWF	OSCCON		; nastaven kmitotu internho osciltoru na 8 MHz

		BCF		STATUS, RP0	; vbr banky 0
; Hlavn smyka programu
LOOP_M
		MOVLW	DEF_COUNT
		MOVWF	count		; count = DEF_COUNT (nahrn vchoz hodnoty)
		MOVLW	DEF_COUNT1
		MOVWF	count1		; count1 = DEF_COUNT1 (nahrn vchoz hodnoty)
LOOP1
		BTFSC	PORTA, 0	; PORTA<0> = 0?
		GOTO	LOOP_M		;  - ne: skok na LOOP_M
		DECFSZ	count		;  - ano: tlatko bylo sepnuto, count = count - 1
		GOTO	LOOP1
		DECFSZ	count1		; count1 = count1 - 1
		GOTO	LOOP1
LOOP2
		BTFSS	PORTA, 0	; PORTA<0> = 1?
		GOTO	LOOP2		;  - ne: skok na LOOP2
							;  - ano: tlatko bylo rozepnuto, pokrauj
		CALL	CHANGE_LED	; aktualizuj vstupn stav
		GOTO	LOOP_M

; Podprogram pro rotaci LED
CHANGE_LED
		BCF		STATUS, C	; C = 0
		BTFSC	PORTB, 7	; PORTB<7> = 0?
		BSF		STATUS, C	;  - ne -> C = 1
		RLF		PORTB, f		; rotace vlevo
		RETURN

		END