	title "Kompartory v reimu SLEEP"

; Seril "Mikrokontrolry PIC", dl 46
; PE 10/2011
;
; Vt pringl
;
; Popis: Tento program demonstruje, e jsou kompartory pln funkn
; 		 i v spornm reimu SLEEP.

     LIST		p=16F88				; nastaven typu procesoru
     #INCLUDE	<P16F88.INC>		; definice promnnch pro tento procesor

; === NASTAVEN KONFIGURANHO SLOVA ===
	__CONFIG	_CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _INTRC_IO
	__CONFIG	_CONFIG2, _IESO_OFF & _FCMEN_OFF

; === PROGRAM ===
RESET	ORG		0x0000	; zatek programu na adrese 0000h

; Inicializace port
	CLRF	PORTA		; inicializace PORTA
	CLRF	PORTB		; inicializace PORTB

	BSF		STATUS, RP0	; vbr banky 1
	MOVLW	b'00000111'	
	MOVWF	ANSEL		; piny RA0 a RA2 jako analogov vstupy
	MOVWF	TRISA		; piny RA0 a RA2 jako vstupy
	CLRF	TRISB		; piny RB<7:0> jako vstupy

; Konfigurace kompartor
	MOVLW	b'00010110'
	MOVWF	CMCON		; C1: Vin-: RA0/AN0, Vin+: RA2/AN2, vstup na RA3
						; C2: Vin-: RA1/AN1, Vin+: RA2/AN2, vstup na RA4
						; vstup C1 invertovan

	SLEEP				; pechod do spornho reimu

	END